
do

	local super=TRAININGGROUNDS_Drawable
	TRAININGGROUNDS_SECRET35_Drawable_ScrollingBackground=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_SECRET35_Drawable_ScrollingBackground
	
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.anchor="TOPLEFT"
		self.allsubframes={}
		self.subframegrid={}
	end
	
	function class:CreateFrame()
		self.frames={}
	
		self.color=TRAININGGROUNDS_ReusableFrames:GetFrame()
		self.color:Show()		
		tinsert(self.frames,self.color)	
	
		self.frame=TRAININGGROUNDS_ReusableFrames:GetFrame()
		self.frame:Show()		
		tinsert(self.frames,self.frame)
		

	end

	function class:SetFrameAppearance()	
		self.owner.width=800
		self.owner.height=800
		self.width=800	--!!!
		self.height=800 --!!!
		
		self.color:SetParent(self.parentframe)
		self.color:SetAllPoints(self.parentframe)
		self.color:Show()		
		self.color.texture:Show()
		self.color.texture:SetColorTexture(0,0,0,1)
		--!!!
		--self.color.texture:SetColorTexture(0,0,1,0.1)
		self.color:SetWidth(self.width)
		self.color:SetHeight(self.height)
		self.color:SetAlpha(1)		
		
		self.frame:SetParent(self.color)
		self.frame:SetAllPoints(self.color)
		self.frame:Show()		
		self.frame.texture:Show()
		self.frame.texture:SetTexture("Interface\\AddOns\\TrainingGrounds_GetSpheres\\Assets\\Graphics\\background.tga","REPEAT","REPEAT")
		self.frame:SetWidth(self.width)
		self.frame:SetHeight(self.height)
		self.frame:SetAlpha(1)
	end
	
	
	
	function class:ArrangeFrame(parentanchor,cposx,cposy,cposz,cangx,cangy,cangz)
		self.color:SetFrameLevel(0) --!!!
		self.frame:SetFrameLevel(1)	--!!!
		--self:SetFrameLevel(50)
		self.frame:SetParent(self.parentframe)		
		if(self.parentframe==UIParent)then		
			print("WARNING:",self.frame.name,"parent is UIParent")
		end
		if(self.frame:GetParent()==UIParent)then
			print("WARNING:",self.frame.name,"parent is UIParent")
		end
		--TODO: correctly set tex coords during SetFrameAppearance as well
		local backgroundmovement=self.owner.player.backgroundmovement
		--TODO: change xoffset to zero once we have a less dubious background
		local backgroundxoffset=0.10
		local x1=2*cangz/(math.pi*2)+backgroundxoffset
		local x2=x1+0.5
		local aspectratio=self.frame:GetHeight()/self.frame:GetWidth()
		local y1=backgroundmovement*0.15*aspectratio
		local y2=y1+0.5*aspectratio
		self.frame.texture:SetTexCoord(x1,y1,x1,y2,x2,y1,x2,y2)		
		self:SetColor(unpack(self.owner.starcolor))
		self.color.texture:SetColorTexture(unpack(self.owner.skycolor))
	end
	
	function class:SetColor(R,G,B,A)
		self.frame.texture:SetGradientAlpha("HORIZONTAL",R,G,B,A,R,G,B,A)
	end
end
