do
	local super=TRAININGGROUNDS_GameObject
	TRAININGGROUNDS_SECRET35_GameObject_WorldGrid = TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_SECRET35_GameObject_WorldGrid
	
	function class:Setup(environment)
		super.Setup(self,environment)
		self.alpha=1	
		--TODO: rename this and GRID_WIDTH to make it clear that they aren't the same thing
		
	end
	
	
	
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)

		self.currenttime=0
		
		self.WORLD_WIDTH=32		
		
		self.grid_contents={}
		for x=1,self.WORLD_WIDTH,1 do
			self.grid_contents[x]={}
			for y=1,self.WORLD_WIDTH,1 do
				self.grid_contents[x][y]=nil
			end
		end		
		
		self.billboard_height=0	-- used for win condition effect only
		self.doublesize=false	-- used for win condition effect only
		
		self.color1={238/256.0,136/256.0, 0/256,1.0}
		self.color2={102/256.0, 34/256.0, 0/256,1.0}
		
		-- yet another reminder that lua arrays are 1-indexed.
			--(player starts at 0,0, so for debug purposes, we place spheres at 32)
			--TODO: maybe player should start at 1,1 instead?
				--TODO: also, modulo the Setup function so we can place spheres at 0 instead of 32
				
		local sphere				
		------------------------------------------------------------------------------------------------
		--sphere=TRAININGGROUNDS_Secret35_Struct_Sphere_Bumper.new()		
		--sphere:Setup(self,32,6)
		------------------------------------------------------------------------------------------------
		-- for x=1,self.WORLD_WIDTH,1 do
			-- for y=1,self.WORLD_WIDTH,1 do
				-- sphere=TRAININGGROUNDS_Secret35_Struct_Sphere_Bumper.new()
				-- if(x~=32 and y~=32)then
					-- sphere:Setup(self,x,y)
				-- end
			-- end
		-- end
		-- --sphere=TRAININGGROUNDS_Secret35_Struct_Sphere_Spring.new()
		-- --sphere:Setup(self,32,10)
		-- for y=7,19,6 do
			-- --sphere=TRAININGGROUNDS_Secret35_Struct_Sphere_Goal.new()
			-- sphere=TRAININGGROUNDS_Secret35_Struct_Sphere_Get.new()
			-- sphere:Setup(self,32,y)
		-- end
		------------------------------------------------------------------------------------------------
		-- -- sphere=TRAININGGROUNDS_Secret35_Struct_Sphere_Get.new()
		-- -- sphere:Setup(self,30,6)
		-- sphere=TRAININGGROUNDS_Secret35_Struct_Sphere_Goal.new()
		-- sphere:Setup(self,31,5)
		-- sphere=TRAININGGROUNDS_Secret35_Struct_Sphere_Bumper.new()
		-- sphere:Setup(self,1,6)
		-- sphere=TRAININGGROUNDS_Secret35_Struct_Sphere_Spring.new()
		-- sphere:Setup(self,32,6)
		-- for y=7,11 do
			-- sphere=TRAININGGROUNDS_Secret35_Struct_Sphere_Bumper.new()
			-- sphere:Setup(self,32,y)
		-- end
		-- sphere=TRAININGGROUNDS_Secret35_Struct_Sphere_Spring.new()
		-- sphere:Setup(self,32,12)		
		-- sphere=TRAININGGROUNDS_Secret35_Struct_Sphere_Spring.new()
		-- sphere:Setup(self,32,18)				
		-- for y=7,15 do
			-- sphere=TRAININGGROUNDS_Secret35_Struct_Sphere_Goal.new()
			-- sphere:Setup(self,1,y)
		-- end		
		------------------------------------------------------------------------------------------------
		
		-- local gbm=TRAININGGROUNDS_Secret35_GridBuildingModule
		-- gbm.Reset()
		-- gbm.AddRow("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX")
		-- gbm.AddRow("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX")
		-- gbm.AddRow("XX.............CC.............XX")
		-- gbm.AddRow("XX.............CC.............XX")
		-- gbm.AddRow("XX..oooo................oooo..XX")
		-- gbm.AddRow("XX..oooo..oo...CC...oo..oooo..XX")
		-- gbm.AddRow("XX..oooo..oo...CC...oo..oooo..XX")
		-- gbm.AddRow("XX..oooo................oooo..XX")
		-- gbm.AddRow("XX.............CC.............XX")
		-- gbm.AddRow("XX.............CC.............XX")
		-- gbm.AddRow("XX........XXXXXXXXXXXX........XX")
		-- gbm.AddRow("XX........XXXXXXXXXXXX........XX")
		-- gbm.AddRow("XX..CoCC..XXXXXXXXXXXX..CCoC..XX")
		-- gbm.AddRow("XX..CooC..XXXXXXXXXXXX..CooC..XX")
		-- gbm.AddRow("XX..CCoC..XXXXXXXXXXXX..CoCC..XX")
		-- gbm.AddRow("XX..CooC..XXXXXXXXXXXX..CooC..XX")
		-- gbm.AddRow("XX..CoCC..XXXXXXXXXXXX..CCoC..XX")
		-- gbm.AddRow("XX..CooC..XXXXXXXXXXXX..CooC..XX")
		-- gbm.AddRow("XX..CCoC..XXXXXXXXXXXX..CoCC..XX")
		-- gbm.AddRow("XX..CCoC..XXXXXXXXXXXX..CoCC..XX")
		-- gbm.AddRow("XX........XXXXXXXXXXXX........XX")
		-- gbm.AddRow("XX........XXXXXXXXXXXX........XX")
		-- gbm.AddRow("XX.............CC.............XX")
		-- gbm.AddRow("XX............................XX")
		-- gbm.AddRow("XX..oooo.......CC.......oooo..XX")
		-- gbm.AddRow("XX..oooo..oo...CC...oo..oooo..XX")		
		-- gbm.AddRow("XX..oooo..oo...CC...oo..oooo..XX")
		-- gbm.AddRow("XX..oooo................oooo..XX")
		-- gbm.AddRow("XX.............CC.............XX")
		-- gbm.AddRow("XX.............CC.............XX")		
		-- gbm.AddRow("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX")
		-- gbm.AddRow("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX")		
		
		
		
		-- local gbm=TRAININGGROUNDS_Secret35_GridBuildingModule
		-- gbm.Reset()
		-- gbm.AddRow("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX")
		-- gbm.AddRow("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX")
		-- gbm.AddRow("XX.............CC.............XX")
		-- gbm.AddRow("XXR............CC.............XX")
		-- gbm.AddRow("XXR......................XXXXXXX")
		-- gbm.AddRow("XXo.....C................XXXXXXX")
		-- gbm.AddRow("XXC......................XXXXXXX")
		-- gbm.AddRow("XXC.....XXXXC........RRRRRRR.XXX")
		-- gbm.AddRow("XXR............CC........XXXXXXX")
		-- gbm.AddRow("XX......C......CC........XXXXXXX")
		-- gbm.AddRow("XX........XXXXXXXXXXXX...X.X.XXX")
		-- gbm.AddRow("XX........XXXXXXXXXXXX........XX")
		-- gbm.AddRow("XX........XXXXXXXXXXXX........XX")
		-- gbm.AddRow("XX........XXXXXXXXXXXX........XX")
		-- gbm.AddRow("XX........XXXXXXXXXXXX........XX")
		-- gbm.AddRow("XX........XXXXXXXXXXXX........XX")
		-- gbm.AddRow("XX........XXXXXXXXXXXX........XX")
		-- gbm.AddRow("XX........XXXXXXXXXXXX........XX")
		-- gbm.AddRow("XX........XXXXXXXXXXXX........XX")
		-- gbm.AddRow("XX........XXXXXXXXXXXX........XX")
		-- gbm.AddRow("XX........XXXXXXXXXXXX........XX")
		-- gbm.AddRow("XX........XXXXXXXXXXXX........XX")
		-- gbm.AddRow("XX.............CC.............XX")
		-- gbm.AddRow("XX............................XX")
		-- gbm.AddRow("XX.............CC.............XX")
		-- gbm.AddRow("XX.............CC.............XX")		
		-- gbm.AddRow("XX.............CC.............XX")
		-- gbm.AddRow("XX............................XX")
		-- gbm.AddRow("XX.............CC.............XX")
		-- gbm.AddRow("XX.............CC.............XX")		
		-- gbm.AddRow("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX")
		-- gbm.AddRow("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX")		
		
		-- gbm.AddRow("Co...CCCCCCCCCXXXXXXXXXXXC..oCCC")
		-- gbm.AddRow("oo...........CXXXXXXXXXXXC..oooo")
		-- gbm.AddRow(".............CXXXCCCXXXXXC......")
		-- gbm.AddRow("..XX.....XX..CXXXC!CXXXXXC......")
		-- gbm.AddRow("..XoooCoooX..CXXXCoCXXXXXC......")
		-- gbm.AddRow("...oooCooo...CXXXCoCXXXXXC......")
		-- gbm.AddRow("C..oooCooo...CCCCCoCXXXXXCCC..CC")
		-- gbm.AddRow("C..CCC.CCC...XoooooCXXXXXXXCX.CX")
		-- gbm.AddRow("C..oooCooo...CCCCCCCXXXXXXXCX.CX")
		-- gbm.AddRow("C..oooCooo...CXXXXXXXXXXXXXC..CX")
		-- gbm.AddRow("C.XoooCoooX..CXXXXXXXXXXXXXC..CX")
		-- gbm.AddRow("C.XX.....XX..CXXXXXXXXXXXXXC.XCX")
		-- gbm.AddRow("C............CXXXXXXXXXXXXXC.XCX")
		-- gbm.AddRow("C............CXXXXXXXXXXXXXC..CX")
		-- gbm.AddRow("CCCCCCCCCCCCCCCCCCCCCCCCCCCC..CC")
		-- gbm.AddRow("XXX!ooooo!.........!ooooo!....CX")
		-- gbm.AddRow("CCCCCCCCCCCCCCCCCCCCCCCCCCCC..CC")
		-- gbm.AddRow("XXXXXXXXXXXCCCCCCCCCCCCCCCXC..CX")
		-- gbm.AddRow("XXXXXCCCXXXC.............CXCX.CX")
		-- gbm.AddRow("XXXXXC!CXXXC.............CXCX.CX")
		-- gbm.AddRow("XXXXXCoCXXXC..XX.....XX..CXC..CX")
		-- gbm.AddRow("XXXXXCoCXXXC..XoooCoooX..CXC..CX")
		-- gbm.AddRow("XXXXXCoCXXXC...oooCooo...CXC.XCX")
		-- gbm.AddRow("XXXXXCoCCCCC...oooCooo...CXC.XCX")
		-- gbm.AddRow("XXXXXCoooooX...CCC.CCC...CXC..CX")
		-- gbm.AddRow("XXXXXCCCCCCC...oooCooo...CXC..CX")
		-- gbm.AddRow("CCCCCCXXXXXC...oooCooo...CCC..CC")
		-- gbm.AddRow(".....CXXXXXC..XoooCoooX.........")
		-- gbm.AddRow("oo...CXXXXXC..XX.....XX.....oooo")
		-- gbm.AddRow("Co...CXXXXXC................oCCC")
		-- gbm.AddRow("Co...CXXXXXC................oCCC")
		-- gbm.AddRow("Co...CXXXXXCCCCCCCCCCCCCCC..oCCC")
		--gbm.Build(self)
		
	end

	

	
	
	
	
	
	
	
	
	
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_SECRET35_Drawable_WorldGrid.new()
		self.drawable:Setup(self,self.environment)
	end
	
		
	function class:GetSphereAt(x,y)		
		x,y=self:GridModulo(x,y)
		--if(y==8)then 
		--print("GSA",x,y,self.grid_contents[x][y])
		--end
		--if(self.grid_contents[x][y])then
			--print("GSA",x,y,self.grid_contents[x][y])
			--error(0)
		--end
		return self.grid_contents[x][y]
	end
	
	function class:GridModulo(x,y)
		--modulo for 1-indexed arrays...
		local mx=((x-1)%self.WORLD_WIDTH)+1
		local my=((y-1)%self.WORLD_WIDTH)+1
		return mx,my
	end
	
	function class:ModuloDistanceBetweenPoints(x1,y1,x2,y2)
		local distx=math.abs(x1-x2)%self.WORLD_WIDTH
		local disty=math.abs(y1-y2)%self.WORLD_WIDTH
		if(distx>self.WORLD_WIDTH/2)then distx=math.abs(distx-self.WORLD_WIDTH)end
		if(disty>self.WORLD_WIDTH/2)then disty=math.abs(disty-self.WORLD_WIDTH)end
		return math.max(distx,disty)	
	end
	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		self.currenttime=self.currenttime+elapsed
	end
	
	
	
	function class:RingOutlineCheck(x,y)
		self:UnmarkAllTiles()
		self:FloodfillAll()
		self:MarkUnfilledSpheresForRings()
		self:ConvertRingMarkedSpheres()
	end
	function class:UnmarkAllTiles()
		for x=1,self.WORLD_WIDTH do
			for y=1,self.WORLD_WIDTH do
				local sphere=self:GetSphereAt(x,y)
				sphere.floodfillmarked=false
				sphere.postfloodfillringmarked=false
			end
		end
	end
	function class:FloodfillAll()
		for x=1,self.WORLD_WIDTH do
			for y=1,self.WORLD_WIDTH do
				local sphere=self:GetSphereAt(x,y)								
				if(sphere:IsAFloodfillOrigin())then
					self:Floodfill(x,y)
				end			
			end
		end
	end
	function class:Floodfill(x,y)
		local sphere=self:GetSphereAt(x,y)
		if(sphere.floodfillmarked)then return end
		if(sphere:IsAGoalSphere())then return end
		sphere.floodfillmarked=true
		self:Floodfill(x-1,y-1)
		self:Floodfill(x,y-1)
		self:Floodfill(x+1,y-1)
		self:Floodfill(x-1,y)
		self:Floodfill(x+1,y)
		self:Floodfill(x-1,y+1)
		self:Floodfill(x,y+1)
		self:Floodfill(x+1,y+1)
	end
	function class:MarkUnfilledSpheresForRings()
		local debugtotal=0
		for x=1,self.WORLD_WIDTH do
			for y=1,self.WORLD_WIDTH do
				local sphere=self:GetSphereAt(x,y)				
				if(not sphere.floodfillmarked)then
					
					if(sphere:IsAGetSphere())then				
						debugtotal=debugtotal+1
						self:MarkSphereForConversionIfValid(x-1,y-1)
						self:MarkSphereForConversionIfValid(x,y-1)
						self:MarkSphereForConversionIfValid(x+1,y-1)
						self:MarkSphereForConversionIfValid(x-1,y)
						self:MarkSphereForConversionIfValid(x,y)
						self:MarkSphereForConversionIfValid(x+1,y)
						self:MarkSphereForConversionIfValid(x-1,y+1)
						self:MarkSphereForConversionIfValid(x,y+1)
						self:MarkSphereForConversionIfValid(x+1,y+1)						
					end
					
				end
			end
		end			
		--print("Total unmarked getspheres:",debugtotal)
	end
	function class:MarkSphereForConversionIfValid(x,y)
		local sphere=self:GetSphereAt(x,y)
		if(sphere:IsAGoalSphere() or sphere:IsAGetSphere())then
			sphere.postfloodfillringmarked=true
		end
	end
	function class:ConvertRingMarkedSpheres()
		for x=1,self.WORLD_WIDTH do
			for y=1,self.WORLD_WIDTH do
				local sphere=self:GetSphereAt(x,y)
					--TODO: if IsAGetSphere then decrement getsphere counter
				if(sphere.postfloodfillringmarked)then
					local ringsphere=TRAININGGROUNDS_Secret35_Struct_Sphere_Ring.new()
					ringsphere:Setup(self,x,y)					
				end
			end
		end
	end
	

	
	function class:PlaceEmerald(player)
		for x=1,self.WORLD_WIDTH do
			for y=1,self.WORLD_WIDTH do
				local nilsphere=TRAININGGROUNDS_Secret35_Struct_Sphere_Nil.new()
				nilsphere:Setup(self,x,y)
			end
		end
		-- must round offset to nearest integer to avoid floating point errors
		local xoffset=math.floor(math.cos(player.grid_facing)+.5)
		local yoffset=math.floor(math.sin(player.grid_facing)+.5)
		
		--print("offset:",xoffset,yoffset)
		--print("player",player.x,player.y)
		
		-- need to round player's coords too, since this doesn't happen at vertex		
		local px=math.floor(player.x+.5)
		local py=math.floor(player.y+.5)		
		--TODO: why do we have to subtract PX but add PY?  this suggests something is wrong with grid_facing
		local finalx=px-xoffset*7
		local finaly=py+yoffset*7
		local sphere=self:GetSphereAt(finalx,finaly)
		--print("final:",sphere.x,sphere.y)
		--TODO: Sphere_Emerald instead
		local goalsphere=TRAININGGROUNDS_Secret35_Struct_Sphere_Emerald.new()
		goalsphere:Setup(self,sphere.x,sphere.y)
		self.doublesize=true
	end
	
	
end