do
	TRAININGGROUNDS_Secret35_GridBuildingModule={}
	local gridbuild=TRAININGGROUNDS_Secret35_GridBuildingModule

	local contents={}
	local currenty=32

	function gridbuild.Reset()
		contents={}
		for x=1,32 do
			contents[x]={}
			for y=1,32 do
				contents[x][y]={}
			end
		end
		currenty=32
	end
	
	function gridbuild.AddRow(str)
		for x=1,32 do
			contents[x][currenty]=string.sub(str,x,x)
		end
		currenty=currenty-1
		--print("currenty:",currenty)
	end
	
	function gridbuild.Build(grid)
		for x=1,32 do
			for y=1,32 do
				local chr=contents[x][y]
				local sphereclass=nil
				--if(false)then
				if(true)then	--!!!
					if(chr=="o")then
						if(not grid.environment.game.scenario.inversemode)then
							sphereclass=TRAININGGROUNDS_Secret35_Struct_Sphere_Get
						else
							sphereclass=TRAININGGROUNDS_Secret35_Struct_Sphere_Goal
						end
					elseif(chr=="X")then
						if(not grid.environment.game.scenario.inversemode)then
							sphereclass=TRAININGGROUNDS_Secret35_Struct_Sphere_Goal
						else
							sphereclass=TRAININGGROUNDS_Secret35_Struct_Sphere_Get
						end					
					elseif(chr=="C")then
						sphereclass=TRAININGGROUNDS_Secret35_Struct_Sphere_Bumper
					elseif(chr=="!")then
						sphereclass=TRAININGGROUNDS_Secret35_Struct_Sphere_Spring
					elseif(chr=="R")then
						sphereclass=TRAININGGROUNDS_Secret35_Struct_Sphere_Ring
					else
						sphereclass=TRAININGGROUNDS_Secret35_Struct_Sphere_Nil
					end
				else
					if(chr~=".")then 
						sphereclass=TRAININGGROUNDS_Secret35_Struct_Sphere_Ring
					else
						sphereclass=TRAININGGROUNDS_Secret35_Struct_Sphere_Nil
					end
				end
				if(sphereclass)then
					local sphere=sphereclass.new()
					sphere:Setup(grid,x,y)
				end
			end
		end
	end

end