function TRAININGGROUNDS_SECRET35_GridLayouts_SetupWorld(scenario)

	local gbm=TRAININGGROUNDS_Secret35_GridBuildingModule
	gbm.Reset()
	
	if(scenario.stagenumber==1)then
		scenario.grid.color1={238/256.0,136/256.0, 0/256,1.0}
		scenario.grid.color2={102/256.0, 34/256.0, 0/256,1.0}		
		scenario.background.skycolor={0/256.0,68/256.0,238/256.0,1.0}
		scenario.background.starcolor={170/256.0,238/256.0,238/256.0,1.0}	
		gbm.AddRow("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX")
		gbm.AddRow("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX")
		gbm.AddRow("XX.............CC.............XX")
		gbm.AddRow("XX.............CC.............XX")
		gbm.AddRow("XX..oooo................oooo..XX")
		gbm.AddRow("XX..oooo..oo...CC...oo..oooo..XX")
		gbm.AddRow("XX..oooo..oo...CC...oo..oooo..XX")
		gbm.AddRow("XX..oooo................oooo..XX")
		gbm.AddRow("XX.............CC.............XX")
		gbm.AddRow("XX.............CC.............XX")
		gbm.AddRow("XX........XXXXXXXXXXXX........XX")
		gbm.AddRow("XX........XXXXXXXXXXXX........XX")
		gbm.AddRow("XX..CoCC..XXXXXXXXXXXX..CCoC..XX")
		gbm.AddRow("XX..CooC..XXXXXXXXXXXX..CooC..XX")
		gbm.AddRow("XX..CCoC..XXXXXXXXXXXX..CoCC..XX")
		gbm.AddRow("XX..CooC..XXXXXXXXXXXX..CooC..XX")
		gbm.AddRow("XX..CoCC..XXXXXXXXXXXX..CCoC..XX")
		gbm.AddRow("XX..CooC..XXXXXXXXXXXX..CooC..XX")
		gbm.AddRow("XX..CCoC..XXXXXXXXXXXX..CoCC..XX")
		gbm.AddRow("XX..CCoC..XXXXXXXXXXXX..CoCC..XX")
		gbm.AddRow("XX........XXXXXXXXXXXX........XX")
		gbm.AddRow("XX........XXXXXXXXXXXX........XX")
		gbm.AddRow("XX.............CC.............XX")
		gbm.AddRow("XX............................XX")
		gbm.AddRow("XX..oooo.......CC.......oooo..XX")
		gbm.AddRow("XX..oooo..oo...CC...oo..oooo..XX")		
		gbm.AddRow("XX..oooo..oo...CC...oo..oooo..XX")
		gbm.AddRow("XX..oooo................oooo..XX")
		gbm.AddRow("XX.............CC.............XX")
		gbm.AddRow("XX.............CC.............XX")		
		gbm.AddRow("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX")
		gbm.AddRow("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX")	
		scenario.perfectringcount=64
		scenario.inverseperfectringcount=383
		scenario.player.x=3
		scenario.player.y=33-3
		scenario.player.xdirection=0
		scenario.player.ydirection=-1
		
	elseif(scenario.stagenumber==2)then
		scenario.grid.color1={34/256.0, 102/256.0, 0/256,1.0}
		scenario.grid.color2={0/256.0, 238/256.0, 170/256,1.0}		
		scenario.background.skycolor={68/256.0,0/256.0,102/256.0,1.0}
		scenario.background.starcolor={238/256.0,238/256.0,238/256.0,1.0}
		gbm.AddRow("XXXX...XXXXXXXXXXXXXXXXXXXXXXXXX")
		gbm.AddRow("XXXX...XXXXXXXXXXXXXXXX.........")
		gbm.AddRow("XXXX...XXXXXXXXXXXXXXXX.........")
		gbm.AddRow("XXXX...XXXXCCCCCCCCCXXX..ooooo..")
		gbm.AddRow("XXXC.......oooo.oooo.....oCCCo..")
		gbm.AddRow("XXXC.......oooo.oooo.....oCCCo..")
		gbm.AddRow("XXXC.......oooo.oooo.....oCCCo..")
		gbm.AddRow("XXXXCCCXXXXCCCCCCCCCXXX..ooooo..")
		gbm.AddRow("XXXXXXXXXXXXXXXXXXXXXXX.........")
		gbm.AddRow("XXXXXXXXXXXXXXXXXXXXXXX.........")
		gbm.AddRow("XXXXXXXXXXXXXXXXXXXXXXXXXX...XXX")
		gbm.AddRow("XXXXXXXXXXXXXXXXXXXXXXXXXX...XXX")
		gbm.AddRow("XXXXXXXXXXX...........XXXC...CXX")
		gbm.AddRow("XXXXXXXXXXX...........XXXC...CXX")
		gbm.AddRow("XXXXXCCCCXX...........XXXC...CCC")
		gbm.AddRow(".....oooo.....ooooo...XXXC......")
		gbm.AddRow(".....oooo.....ooooo...XXXC......")
		gbm.AddRow(".....oooo.....ooooo...XXXC......")
		gbm.AddRow("XXXXXCCCCXX...........XXXC...CCC")
		gbm.AddRow("XXXXXXXXXXX...........XXXC...CXX")
		gbm.AddRow("XXXXXXXXXXX...........XXXC...CXX")
		gbm.AddRow("XXXXXXXXXXXXXXX...XXXXXXXCoooCXX")
		gbm.AddRow("XXXXXXXXXXXXXXCoooCXXXXXXCoooCXX")
		gbm.AddRow("X.........XXXXCoooCXXXXXXCoooCXX")
		gbm.AddRow("X.........XXXXCoooCXXXXXXCoooCXX")
		gbm.AddRow("X..ooooo..XXXCCoooCCXXCCCC...CXX")
		gbm.AddRow("X..ooooo..............oooo...C..")
		gbm.AddRow("X..ooCoo..............oooo...C..")
		gbm.AddRow("X..ooooo..............oooo...C..")
		gbm.AddRow("X..ooooo..XXXXCCCCCXXXCCCCCCCCXX")
		gbm.AddRow("X.........XXXXXXXXXXXXXXXXXXXXXX")
		gbm.AddRow("X.........XXXXXXXXXXXXXXXXXXXXXX")
		scenario.perfectringcount=111
		scenario.inverseperfectringcount=424
		scenario.player.x=17
		scenario.player.y=33-28
		scenario.player.xdirection=-1
		scenario.player.ydirection=0		
		
	elseif(scenario.stagenumber==3)then		
		scenario.grid.color1={238/256.0, 102/256.0, 0/256,1.0}
		scenario.grid.color2={238/256.0, 238/256.0, 170/256,1.0}		
		scenario.background.skycolor={0/256.0,68/256.0,238/256.0,1.0}
		scenario.background.starcolor={238/256.0,238/256.0,170/256.0,1.0}	
		gbm.AddRow("XXXXXXXXXXXXXXXXXXXXXXXXXCoCXXXX")
		gbm.AddRow("X......XX......CC......XX......X")
		gbm.AddRow("X......XX......oo.oooo.XX......X")
		gbm.AddRow("X..oo..XX..CC..CC.oooo.XX..CC..X")
		gbm.AddRow("X..oo..XX..CC..XX.oooo.XX..CC..X")
		gbm.AddRow("X......XX......XX.oooo.XX......X")
		gbm.AddRow("X......XX......XX......XX......X")
		gbm.AddRow("XCoCXXXXXCoCXXXXXCoCXXXXXXXXCoCX")
		gbm.AddRow("XCoCXXXXXCoCXXXXXCoCXXXXXXXXCoCX")
		gbm.AddRow("X......XX......XX......XX......X")
		gbm.AddRow("X.oooo.XX......XX......XX.oooo.X")
		gbm.AddRow("X.oooo.XX..CC..XX..CC..XX.oooo.X")
		gbm.AddRow("X.oooo.CC..CC..XX..CC..CC.oooo.X")
		gbm.AddRow("X.oooo.oo......XX......oo.oooo.X")
		gbm.AddRow("X......CC......XX......CC......X")
		gbm.AddRow("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX")
		gbm.AddRow("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX")
		gbm.AddRow("X......CC......XX......CC......X")
		gbm.AddRow("X.oooo.oo......XX......oo......X")
		gbm.AddRow("X.oooo.CC..CC..XX..CC..CC..oo..X")
		gbm.AddRow("X.oooo.XX..CC..CC..CC..XX..oo..X")
		gbm.AddRow("X.oooo.XX......oo......XX......X")
		gbm.AddRow("X......XX......CC......XX......X")
		gbm.AddRow("XCoCXXXXXXXXXXXXXXXXXXXXXXXXCoCX")
		gbm.AddRow("XCoCXXXXXXXXXXXXXXXXXXXXXXXXCoCX")
		gbm.AddRow("X......XX......CC......XX......X")
		gbm.AddRow("X......XX......oo.oooo.XX..C...X")
		gbm.AddRow("X..CC..XX..CC..CC.oooo.XX..RRC.X")
		gbm.AddRow("X..CC..CC..CC..XX.oooo.XX.CRR..X")
		gbm.AddRow("X......oo......XX.oooo.XX...C..X")
		gbm.AddRow("X......CC......XX......XX......X")
		gbm.AddRow("XXXXXXXXXXXXXXXXXXXXXXXXXCoCXXXX")
		scenario.perfectringcount=84
		scenario.inverseperfectringcount=4		
		scenario.player.x=2
		scenario.player.y=33-2
		scenario.player.xdirection=0
		scenario.player.ydirection=-1	
	elseif(scenario.stagenumber==4)then
		scenario.grid.color1={238/256.0, 238/256.0, 238/256,1.0}
		scenario.grid.color2={204/256.0, 0/256.0, 0/256,1.0}		
		scenario.background.skycolor={0/256.0,0/256.0,0/256.0,1.0}
		scenario.background.starcolor={256/256.0,256/256.0,0/256.0,1.0}	
		gbm.AddRow("CCCCCCCCCCCCCXXCCCXXCCCCCCCCCCCC")
		gbm.AddRow("CXXXXXXXXXXXXXX.o.XXXXXXXXXXXXXC")
		gbm.AddRow("CXXXXXXXXXXXXXX...XXXXXXXXXXXXXC")
		gbm.AddRow("CXX..........................XXC")
		gbm.AddRow("CXX...........CoCC...........XXC")
		gbm.AddRow("CXX..CCCCCC...Cooo...CCCCCC..XXC")
		gbm.AddRow("CXX..Cooooo...CCCC...oooooC..XXC")
		gbm.AddRow("CXX..CoooCC..........CCoooC..XXC")
		gbm.AddRow("CXX..CoooC............CoooC..XXC")
		gbm.AddRow("CXX..CCCoC..X..CC..X..CCCoC..XXC")
		gbm.AddRow("CXX....CoC..X..CC..X....CoC..XXC")
		gbm.AddRow("CXX.........X......X.........XXC")
		gbm.AddRow("CXX.......XXX.oooo.XXX.......XXC")
		gbm.AddRow("CXX...........oooo...........XXC")
		gbm.AddRow("CXX...CoC...oooooooo...CoC...XXC")
		gbm.AddRow("CXX...CoC.CCoooCCoooCC.CoC...XXC")
		gbm.AddRow("CXX...CoC.CCoooCCoooCC.CoC...XXC")
		gbm.AddRow("CXX...CoC...oooooooo...CoC...XXC")
		gbm.AddRow("CXX...........oooo...........XXC")
		gbm.AddRow("CXX.......XXX.oooo.XXX.......XXC")
		gbm.AddRow("CXX.........X......X.........XXC")
		gbm.AddRow("CXX..CoC....X..CC..X..CoC....XXC")
		gbm.AddRow("CXX..CoCCC..X..CC..X..CoCCC..XXC")
		gbm.AddRow("CXX..CoooC............CoooC..XXC")
		gbm.AddRow("CXX..CoooCC..........CCoooC..XXC")
		gbm.AddRow("CXX..Cooooo...CCCC...oooooC..XXC")
		gbm.AddRow("CXX..CCCCCC...oooC...CCCCCC..XXC")
		gbm.AddRow("CXX...........CCoC...........XXC")
		gbm.AddRow("CXX..........................XXC")
		gbm.AddRow("CXXXXXXXXXXXXXX.o.XXXXXXXXXXXXXC")
		gbm.AddRow("CXXXXXXXXXXXXXXCCCXXXXXXXXXXXXXC")
		gbm.AddRow("CCCCCCCCCCCCCXX.o.XXCCCCCCCCCCCC")
		scenario.perfectringcount=80
		scenario.inverseperfectringcount=220
		scenario.player.x=14
		scenario.player.y=33-7
		scenario.player.xdirection=-1
		scenario.player.ydirection=0			
	elseif(scenario.stagenumber==5)then
		scenario.grid.color1={68/256.0, 34/256.0, 68/256,1.0}
		scenario.grid.color2={238/256.0,136/256.0, 0/256,1.0}		
		scenario.background.skycolor={0/256.0,0/256.0,34/256.0,1.0}
		scenario.background.starcolor={170/256.0,238/256.0,238/256.0,1.0}
		gbm.AddRow(".XXXXXCCCXXXXX...XXXXXXXXXXXXX..")
		gbm.AddRow(".XXXXXXXXXXXXX...XXXXXCCCXXXXX..")
		gbm.AddRow(".XXXXXXXXXXXXX...C....ooo....X..")
		gbm.AddRow(".XXXXXXXXXXXXX...C....ooo....X..")
		gbm.AddRow(".XXXXXXXXXXXXX...C....ooo....X..")
		gbm.AddRow(".XXXXXXXXXXXXX...XXXXXCCCXXXXX..")
		gbm.AddRow(".XXXXXXXXXXXXX...XXXXXXXXXXXXX..")
		gbm.AddRow(".XXXXXXXXXXXXXCCCXXXXXXXXXXXXX..")
		gbm.AddRow(".XXXXXXXXXXXXX...XXXXXXXXXXXXX..")
		gbm.AddRow("CXXXXXXXXXXXXX...XXXXXXXXXXXXXCC")
		gbm.AddRow(".....XXXXXXXXX...XXXXXXXXX......")
		gbm.AddRow(".....XXXXXXXXXCCCXXXXXXXXX......")
		gbm.AddRow("ooo..XXXXX...........XXXXX..ooo.")
		gbm.AddRow("ooo..XXXXX...........XXXXX..ooo.")
		gbm.AddRow("ooo..XXXXX....C.C....XXXXX..ooo.")
		gbm.AddRow(".....XXXXX...oC.Co...XXXXX......")
		gbm.AddRow(".....XXXXX..CCC.CCC..XXXXX......")
		gbm.AddRow("CC...XXXXX.....C.....XXXXX...CC.")
		gbm.AddRow("CC...XXXXX..CCC.CCC..XXXXX...CC.")
		gbm.AddRow(".....XXXXX...oC.Co...XXXXX......")
		gbm.AddRow("ooo..XXXXX....C.C....XXXXX..ooo.")
		gbm.AddRow("ooo..XXXXX...........XXXXX..ooo.")
		gbm.AddRow("ooo..XXXXX...........XXXXX..ooo.")
		gbm.AddRow(".....XXXXXXXXXCCCXXXXXXXXX......")
		gbm.AddRow(".....XXXXXXXXX...XXXXXXXXX......")
		gbm.AddRow("CXXXXXXXXXXXXX...XXXXXXXXXXXXXCC")
		gbm.AddRow(".XXXXXXXXXXXXX...XXXXXXXXXXXXX..")
		gbm.AddRow(".XXXXXXXXXXXXXCCCXXXXXXXXXXXXX..")
		gbm.AddRow(".XXXXXCCCXXXXX...XXXXXXXXXXXXX..")
		gbm.AddRow(".X....ooo....C...XXXXXXXXXXXXX..")
		gbm.AddRow(".X....ooo....C...XXXXXXXXXXXXX..")
		gbm.AddRow(".X....ooo....C...XXXXXXXXXXXXX..")		
		scenario.perfectringcount=54
		scenario.inverseperfectringcount=534
		scenario.player.x=16
		scenario.player.y=33-2
		scenario.player.xdirection=0
		scenario.player.ydirection=1	
		
	elseif(scenario.stagenumber==6)then
		scenario.grid.color1={0/256.0, 68/256.0, 204/256,1.0}
		scenario.grid.color2={170/256.0,238/256.0, 238/256,1.0}		
		scenario.background.skycolor={0/256.0,204/256.0,238/256.0,1.0}
		scenario.background.starcolor={238/256.0,238/256.0,170/256.0,1.0}
		gbm.AddRow("XX..XXXXXXXXXXXXXX..XXXXXXXXXXXX")
		gbm.AddRow("XX..XXXXXXXXXXXXXX..XXXXXXXXXXXX")
		gbm.AddRow("XXooXXXXXXXXXXXXXXooXXXXXXXXXXXX")
		gbm.AddRow("XXooXXXXXXXXXXXXXXooXXXXXXXXXXXX")
		gbm.AddRow(".......XXXXXXXX........XXXXXXXX.")
		gbm.AddRow("CC..CC.XXXXXXXX.CC..CC.XXXXXXXX.")
		gbm.AddRow("CooooC.XXXXXXXX.CooooC.XXXXXXXX.")
		gbm.AddRow(".oooo..oo....oo..oooo..oo....oo.")
		gbm.AddRow(".oooo..oo....oo..oooo..oo....oo.")
		gbm.AddRow("CooooC.XXXXXXXX.CooooC.XXXXXXXX.")
		gbm.AddRow("CC..CC.XXXXXXXX.CC..CC.XXXXXXXX.")
		gbm.AddRow(".......XXXXXXXX........XXXXXXXX.")
		gbm.AddRow("XXooXXXXXXXXXXXXXXooXXXXXXXXXXXX")
		gbm.AddRow("XXooXXXXXXXXXXXXXXooXXXXXXXXXXXX")
		gbm.AddRow("XX..XXXXXXXXXXXXXX..XXXXXXXXXXXX")
		gbm.AddRow("XX..XXXXXXXXXXXXXX..XXXXXXXXXXXX")
		gbm.AddRow("XX..XXXXXXXXXXXXXX..XXXXXXXXXXXX")
		gbm.AddRow("XX..XXXXXXXXXXXXXX..XXXXXXXXXXXX")
		gbm.AddRow("XXooXXXXXXXXXXXXXXooXXXXXXXXXXXX")
		gbm.AddRow("XXooXXXXXXXXXXXXXXooXXXXXXXXXXXX")		
		gbm.AddRow(".......XXXXXXXX........XXXXXXXX.")
		gbm.AddRow("CC..CC.XXXXXXXX.CC..CC.XXXXXXXX.")
		gbm.AddRow("CooooC.XXXXXXXX.CooooC.XXXXXXXX.")
		gbm.AddRow(".oooo..oo....oo..oooo..oo....oo.")
		gbm.AddRow(".oooo..oo....oo..oooo..oo....oo.")
		gbm.AddRow("CooooC.XXXXXXXX.CooooC.XXXXXXXX.")
		gbm.AddRow("CC..CC.XXXXXXXX.CC..CC.XXXXXXXX.")
		gbm.AddRow(".......XXXXXXXX........XXXXXXXX.")
		gbm.AddRow("XXooXXXXXXXXXXXXXXooXXXXXXXXXXXX")
		gbm.AddRow("XXooXXXXXXXXXXXXXXooXXXXXXXXXXXX")			
		gbm.AddRow("XX..XXXXXXXXXXXXXX..XXXXXXXXXXXX")
		gbm.AddRow("XX..XXXXXXXXXXXXXX..XXXXXXXXXXXX")
		scenario.perfectringcount=64
		scenario.inverseperfectringcount=639
		scenario.player.x=4
		scenario.player.y=33-2
		scenario.player.xdirection=0
		scenario.player.ydirection=1	
		
	elseif(scenario.stagenumber==7)then
		scenario.grid.color1={102/256.0, 34/256.0, 170/256,1.0}
		scenario.grid.color2={238/256.0,204/256.0, 0/256,1.0}		
		scenario.background.skycolor={0/256.0,102/256.0,238/256.0,1.0}
		scenario.background.starcolor={238/256.0,238/256.0,238/256.0,1.0}	
		gbm.AddRow("XXXXXXXXX.....CCCC.....XXXXXXXXX")
		gbm.AddRow("XXXXXXXXX...ooX..Xoo...XXXXXXXXX")
		gbm.AddRow("XXXXXXXXX...ooX..Xoo...XXXXXXXXX")
		gbm.AddRow("XXXXXXXXX...XXX..XXX...XXXXXXXXX")
		gbm.AddRow("XXXXXXXXX...CCCXXCCC...XXXXXXXXX")
		gbm.AddRow("XXXXXXXXCCCoCXCRRCXCoCCCXXXXXXXX")
		gbm.AddRow("XXXXXXXXXXCoCXCRRCXCoCXXXXXXXXXX")
		gbm.AddRow("XXXXXXXXXXCoCXCRRCXCoCXXXXXXXXXX")			
		gbm.AddRow("XXXXXXXXXXCoCXCCCCXCoCXXXXXXXXXX")	
		gbm.AddRow("XXXXXXXXXXCoCXXXXXXCoCXXXXXXXXXX")	
		gbm.AddRow("XXXXXXXXXXCoCXXXXXXCoCXXXXXXXXXX")	
		gbm.AddRow("XXXXXXXXXXCoCXXXXXXCoCXXXXXXXXXX")	
		gbm.AddRow("XXXXXXXXXXC..........CXXXXXXXXXX")
		gbm.AddRow("XXXXXXXXXXC...XCCX...CXXXXXXXXXX")
		gbm.AddRow("X.............XCCX.............X")
		gbm.AddRow("C..............................C")
		gbm.AddRow("o..XXXXXXXX..........XXXXXXXX..o")
		gbm.AddRow("o..XCCCCCCCXXX....XXXCCCCCCCX..o")
		gbm.AddRow("CXXXCCCCCC.ooX....Xoo.CCCCCCXXXC")
		gbm.AddRow("CCCCCCCCC..ooX....Xoo..CCCCCCCCC")
		gbm.AddRow("CCCCCCCC.....CX..XC.....CCCCCCCC")
		gbm.AddRow("CXXXC....X..CCX..XCC..X....CXXXC")
		gbm.AddRow("o..XC......CCCX..XCCC......CX..o")
		gbm.AddRow("o..XC.....CXXXX..XXXXC.....CX..o")
		gbm.AddRow("C..oXXX...CX........XC...XXXo..C")
		gbm.AddRow("X..oooX...CX........XC...Xooo..X")
		gbm.AddRow("X..oooXCCCCX..XXXX..XCCCCXooo..X")
		gbm.AddRow("X..ooooXXXXX..XXXX..XXXXXoooo..X")
		gbm.AddRow("X.............XXXX.............X")
		gbm.AddRow("X.............XXXX.............X")
		gbm.AddRow("XXXXXXXXX.....XXXX.....XXXXXXXXX")				
		gbm.AddRow("XXXXXXXXX.....CCCC.....XXXXXXXXX")	
		scenario.perfectringcount=74
		scenario.inverseperfectringcount=328
		scenario.player.x=17
		scenario.player.y=33-21
		scenario.player.xdirection=0
		scenario.player.ydirection=1			
		
	elseif(scenario.stagenumber==8)then
		scenario.grid.color1={0/256.0, 0/256.0, 170/256,1.0}
		scenario.grid.color2={68/256.0,170/256.0, 0/256,1.0}		
		scenario.background.skycolor={0/256.0,0/256.0,68/256.0,1.0}
		scenario.background.starcolor={238/256.0,238/256.0,204/256.0,1.0}	
		gbm.AddRow(".X..............oCo............X")
		gbm.AddRow("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX")
		gbm.AddRow(".X..............oCo.............")
		gbm.AddRow(".X.XXXXXXXXXXXXXXXXXXXXXXXXXXXXX")
		gbm.AddRow(".X.X...........................X")
		gbm.AddRow(".X.X.XXXXXXXXXXXXXXXXXXXXXXXXXXX")
		gbm.AddRow(".X.X.X..........RCo............X")
		gbm.AddRow(".X.X.X.XXXXXXXXXXXXXXXXXXXXXXX.X")
		gbm.AddRow(".X.X.X.X........oCo..........X.X")
		gbm.AddRow(".X.X.X.X.XXXXXXXXXXXXXXXXXXX.X.X")
		gbm.AddRow(".X.X.X.X.X......oCo........X.X.X")
		gbm.AddRow(".X.X.X.X.X.XXXXXXXXXXXXXXX.X.X.X")
		gbm.AddRow(".X.X.X.X.X.X....RCo......X.X.X.X")
		gbm.AddRow(".X.X.X.X.X.X.XXXXXXXXXXX.X.X.X.X")
		gbm.AddRow("oXoX.XoXoXoXoX..oCo....X.X.X.X.X")
		gbm.AddRow("CXCX.XCXCXCXCXoXXXXXXXoXoXoXRXoX")
		gbm.AddRow("oXRX.XoXoXRXoXCX.RCo.XCXCXCXCXCX")
		gbm.AddRow(".X.X.X.X.X.X.XoX.XXX.XoXoXoXoXoX")
		gbm.AddRow(".C.C.C.C.C.C.X.X.o!C.C.C.C.C.C.C")
		gbm.AddRow(".X.X.X.X.X.X.X.XXXXX.X.X.X.X.X.X")
		gbm.AddRow(".X.X.X.X.X.X.X..oCo..X.X.X.X.X.X")
		gbm.AddRow(".X.X.X.X.X.X.XXXXXXXXX.X.X.X.X.X")
		gbm.AddRow(".X.X.X.X.X.X....oCo....X.X.X.X.X")
		gbm.AddRow(".X.X.X.X.X.XXXXXXXXXXXXX.X.X.X.X")
		gbm.AddRow(".X.X.X.X.X......oCo......X.X.X.X")
		gbm.AddRow(".X.X.X.X.XXXXXXXXXXXXXXXXX.X.X.X")
		gbm.AddRow(".X.X.X.X........oCR........X.X.X")
		gbm.AddRow(".X.X.X.XXXXXXXXXXXXXXXXXXXXX.X.X")
		gbm.AddRow(".X.X.X..........oCo..........X.X")
		gbm.AddRow(".X.X.XXXXXXXXXXXXXXXXXXXXXXXXX.X")
		gbm.AddRow(".X.X.........................X.X")
		gbm.AddRow(".X.XXXXXXXXXXXXXXXXXXXXXXXXXXX.X")	
		scenario.perfectringcount=7
		scenario.inverseperfectringcount=7
		scenario.player.x=1
		scenario.player.y=33-1
		scenario.player.xdirection=0
		scenario.player.ydirection=1		
		
	elseif(scenario.stagenumber==9)then	
		scenario.grid.color1={34/256.0, 238/256.0, 0/256,1.0}
		scenario.grid.color2={204/256.0,238/256.0, 136/256,1.0}		
		scenario.background.skycolor={0/256.0,68/256.0,238/256.0,1.0}
		scenario.background.starcolor={170/256.0,238/256.0,238/256.0,1.0}
		gbm.AddRow("..CXXC...CXXXCXXXXC.....CXC.....")
		gbm.AddRow("...CC.....CXXXXXXC...C...C....C.")
		gbm.AddRow("...........CXXXXC...ooo......ooo")
		gbm.AddRow("C...........CXXC!..CoooC....Cooo")
		gbm.AddRow("....C.......!CXXC...ooo......ooo")
		gbm.AddRow("...CXC......CXXXXC...C...C....C.")
		gbm.AddRow("..CXXC.....CXXXXXC......CXC.....")
		gbm.AddRow(".CXXC.....CXXXXXC......CXXXC....")
		gbm.AddRow("CXXC.......CXXXC........CXXXC...")
		gbm.AddRow("XXC.........CXC..........CXXXC.C")
		gbm.AddRow("XC.....C.....C.......C....CXXXCX")
		gbm.AddRow("C.....ooo...........CCC....CXXXX")
		gbm.AddRow("!....CoooC.........Coooo....CXXX")
		gbm.AddRow("C.....ooo.........CCooooC....CXX")
		gbm.AddRow("XC.....C.....CC....CooooCC...!CX")
		gbm.AddRow("XXC.........CXXC....ooooC....CXX")
		gbm.AddRow("XXXC.......CXXXXC....CCC....CXXX")
		gbm.AddRow("XXXXC.....CXXXXXXC....C....CXXXC")
		gbm.AddRow("CXXXXC...CXXXXXXXXC.......CXXXC.")
		gbm.AddRow(".CXXXXC!CXXXCXXXXC.......CXXXC..")
		gbm.AddRow("..CXXXXCXXXC!CXXC.......CXXXC...")
		gbm.AddRow("...CXXXXXXC...CC....C....CXC....")
		gbm.AddRow("C...CXXXXC.........CCC....C...Co")
		gbm.AddRow("o...!CXXC.........Coooo.......oR")
		gbm.AddRow("C...CXXC...CoC...CCooooC......Co")
		gbm.AddRow("...CXXC!...oRo....CooooCC.......")
		gbm.AddRow("..CXXXXC...CoC.....ooooC........")
		gbm.AddRow(".CXXXXXXC...........CCC.........")
		gbm.AddRow("CXXXXXXXXC...........C....C.....")
		gbm.AddRow("XXXXXXXXXXC..............CXC...C")
		gbm.AddRow("CXXXXXXCXXXC...CC.......CXXXC...")
		gbm.AddRow(".CXXXXC!CXXXC.CXXC.....CXXXC....")
		scenario.perfectringcount=61
		scenario.inverseperfectringcount=68
		scenario.player.x=22
		scenario.player.y=33-32
		scenario.player.xdirection=0
		scenario.player.ydirection=1			
		
	elseif(scenario.stagenumber==10)then
		scenario.grid.color1={238/256.0, 102/256.0, 0/256,1.0}
		scenario.grid.color2={136/256.0,238/256.0, 204/256,1.0}		
		scenario.background.skycolor={0/256.0,68/256.0,238/256.0,1.0}
		scenario.background.starcolor={170/256.0,238/256.0,238/256.0,1.0}	
		gbm.AddRow("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX")
		gbm.AddRow("XXXXXXXXXXXXXXXXXXXXXXXXXXCCCCCC")
		gbm.AddRow("XXXXXXXXXCCCCCCXXXXXCCCCCCC....C")
		gbm.AddRow("XXXXXXXXXC....CCCCCCC.XXXCC....C")
		gbm.AddRow("XXXXXXXXXC....!....!..ooX......C")
		gbm.AddRow("XXXXXXXXXC....CCC.CCC.XXXCC....C")
		gbm.AddRow("XXXXXXXXXCCCCCCXC.CXCCCCCCC....C")
		gbm.AddRow("XXXXXXXXXXXXXXXXCoCXXXXXXXCC!CCC")
		gbm.AddRow("CCCCCCCCCCXXXXXXCoCXXXXXXXXXXXXX")
		gbm.AddRow("Cooo..oooCXXCCCCC.CXXXXXXXXXXXXX")
		gbm.AddRow("CooXCCXooCXXC.....CXXXXXXXXXXXXX")
		gbm.AddRow("CoXXCCXXoCXXC.CCC.CXXXXXXXXXXXXX")
		gbm.AddRow("C.CCCC...CXXC.....CXXXXXXXXC!CXX")
		gbm.AddRow("C.CXXC...CXXC.CCCCCXXXXXXXXC.CXX")
		gbm.AddRow("C.CXXC...CCCC.CXXXXXXXXXXXXC.CXX")
		gbm.AddRow("C.CXXC...ooo..CXXXXXXXXXXXXCCCXX")
		gbm.AddRow("C.CXXCCCCCCCCCCXXXXXXXXXXXXC.CXX")
		gbm.AddRow("CoCXXXXXXXXXXXXXXXCCCCCCCCCC.CXX")
		gbm.AddRow("CoCCCCXXXXXXXXXXXXCooo....oooCXX")
		gbm.AddRow("C....CXXXXCCCCCCXXCooXCCCCXoXCXX")
		gbm.AddRow("C....!XXXX!....CXXCoXXCXXCXXXCXX")
		gbm.AddRow("C....CXXXXC....CXXC.CCCXXCCCCCXX")
		gbm.AddRow("CCCCCCXXXXCCCC.CXXC.CXXXXXXXXXXX")
		gbm.AddRow("XXXXXXXXXXXXXC.CXXC.CXXXXXXXXXXX")
		gbm.AddRow("CCCCXXXXCCCCCC.CXXC.CCCXXXXXCCCC")
		gbm.AddRow("...CXXXXC.XXX..CXXC...CCXXXXC...")
		gbm.AddRow("oo.!XXXX!.Xoo..CXXC....!XXXX!.oo")
		gbm.AddRow("...CXXXXC.XXX..CXXC...CCXXXXC...")
		gbm.AddRow("CCCCXXXXCCCCCCCCXXCCCCCXXXXXCCCC")
		gbm.AddRow("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX")
		gbm.AddRow("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX")
		gbm.AddRow("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX")
		scenario.perfectringcount=54
		scenario.inverseperfectringcount=443
		scenario.player.x=20
		scenario.player.y=33-27
		scenario.player.xdirection=0
		scenario.player.ydirection=1			
		
	elseif(scenario.stagenumber==11)then
		scenario.grid.color1={204/256.0, 0/256.0, 170/256,1.0}
		scenario.grid.color2={170/256.0,204/256.0, 0/256,1.0}		
		scenario.background.skycolor={0/256.0,0/256.0,34/256.0,1.0}
		scenario.background.starcolor={0/256.0,68/256.0,238/256.0,1.0}	
		gbm.AddRow("CCCCCCCCCCCCCX....XCCCCCCCCCCCCC")
		gbm.AddRow("CCCCCCCCCCCCCX....XCCCCCCCCCCCCC")
		gbm.AddRow("CCCCCCCCCCXXXXCCCCXXXXCCCCCCCCCC")
		gbm.AddRow("CCCCCCCCCXX..........XXCCCCCCCCC")
		gbm.AddRow("CCCCXXXXXXX..oCCCCo..XXXXXXXCCCC")
		gbm.AddRow("CCCCXCCCCCC..oCCCCo..CCCCCCXCCCC")
		gbm.AddRow("CCCCXC....o..........o....CXCCCC")
		gbm.AddRow("CCCCXC.XXoC.XX!!!!XX.CoXX.CXCCCC")
		gbm.AddRow("CCCCXC.XooC.XX....XX.CooX.CXCCCC")
		gbm.AddRow("CCCXXC.oooC.XX.oo.XX.Cooo.CXXCCC")
		gbm.AddRow("CCXXXCoCCCC.XX.oo.XX.CCCCoCXXXCC")
		gbm.AddRow("CCX.........XX.oo.XX.........XCC")
		gbm.AddRow("CCX....XXXXXCC....CCXXXXX....XCC")
		gbm.AddRow("CCX....XXXXXCC!!!!CCXXXXX....XCC")
		gbm.AddRow("CCX.CC.!CCC!..oooo..!CCC!.CC.XCC")
		gbm.AddRow("CCX.oo.!CCC!..oooo..!CCC!.CC.XCC")
		gbm.AddRow("CCX.oo.!CCC!..oooo..!CCC!.CC.XCC")
		gbm.AddRow("CCX.oo.!CCC!..oooo..!CCC!.CC.XCC")
		gbm.AddRow("CCX....XXXXXCC!!!!CCXXXXX....XCC")
		gbm.AddRow("CCX....XXXXXCC....CCXXXXX....XCC")
		gbm.AddRow("CCX.........XX.oo.XX.........XCC")
		gbm.AddRow("CCXXXCoCCCC.XX.oo.XX.CCCCoCXXXCC")
		gbm.AddRow("CCCXXC.oooC.XX.oo.XX.Cooo.CXXCCC")
		gbm.AddRow("CCCCXC.XooC.XX....XX.CooX.CXCCCC")
		gbm.AddRow("CCCCXC.XXoC.XX!!!!XX.CoXX.CXCCCC")
		gbm.AddRow("CCCCXC....o..!CCCC!..o....CXCCCC")
		gbm.AddRow("CCCCXCCCCCCXXXCXXCXXXCCCCCCXCCCC")
		gbm.AddRow("CCCCXXXXXXXXXXCCCCXXXXXXXXXXCCCC")
		gbm.AddRow("CCCCCCCCCXXXXXRRRRXXXXXCCCCCCCCC")
		gbm.AddRow("CCCCCCCCCCCCCXRRRRXCCCCCCCCCCCCC")
		gbm.AddRow("CCCCCCCCCCCCCXRRRRXCCCCCCCCCCCCC")
		gbm.AddRow("CCCCCCCCCCCCCXCCCCXCCCCCCCCCCCCC")
		scenario.perfectringcount=64
		scenario.inverseperfectringcount=30
		scenario.player.x=21
		scenario.player.y=33-6
		scenario.player.xdirection=-1
		scenario.player.ydirection=0			
		
		
	elseif(scenario.stagenumber==12)then
		scenario.grid.color1={0/256.0, 0/256.0, 204/256,1.0}
		scenario.grid.color2={204/256.0,170/256.0, 0/256,1.0}		
		scenario.background.skycolor={0/256.0,170/256.0,238/256.0,1.0}
		scenario.background.starcolor={238/256.0,238/256.0,238/256.0,1.0}
		gbm.AddRow("X!!!!!!!!!!XXXX!!!!!!!!!!XCoCXXX")
		gbm.AddRow("X!oooooooo!XXXX!.oooooo.!XCoCXXX")
		gbm.AddRow("X!oCCCCCCo!XXXX!oCCCCCCo!XCoCXXX")
		gbm.AddRow("X!oCRRRRCo!XXXX!oCRRRRCo!XCoCXXX")
		gbm.AddRow("X!oCRRRRCo!XXXX!oCRRRRCo!XCoCXXX")
		gbm.AddRow("X!oCRRRRCo!XXXX!oCRRRRCo!XCCCXXX")
		gbm.AddRow("X!oCRRRRCo!XXXX!oCRRRRCo!XXXXXXX")
		gbm.AddRow("X!oCCCCCCo!XXXX!oCCCCCCo!XXXXXXX")
		gbm.AddRow("X!oooooooo!XXXX!.oooooo.!XXXXXXX")
		gbm.AddRow("X!!!!!!!!!!XXXX!!!!!!!!!!XXXXXXX")
		gbm.AddRow("XXXXXXXXXXXXXXXCCCCCCCCXXX!!!!!!")
		gbm.AddRow("XXXXXXXXXXXXXXXC.oooo!CXXX!oooo!")
		gbm.AddRow("XXXXXXXXXXXXXXXC.CCCCCCXXX!oCCo!")
		gbm.AddRow("XXXXXXXXXXXXXXXX.XXXXXXXXX!oCCo!")
		gbm.AddRow("X!!!!!!!!!!XXXX!.!!!!!!!!X!oCCo!")
		gbm.AddRow("X!oooooooo!XXXX!oooooooo!X!oCCo!")
		gbm.AddRow("X!oCCCCCCo!XXXX!oCCCCCCo!X!oCCo!")
		gbm.AddRow("X!oCRRRRCo!XXXX!oCRRRRCo!X!oooo!")
		gbm.AddRow("X!oCRRRRCo!XXXX!oCRRRRCo!X!!!!!!")
		gbm.AddRow("X!oCRRRRCo!XXXX!oCRRRRCo!XXXXXXX")
		gbm.AddRow("X!oCRRRRCo!XXXX!oCRRRRCo!XXXXXXX")
		gbm.AddRow("X!oCCCCCCo!XXXX!oCCCCCCo!XXXXXXX")
		gbm.AddRow("X!oooooooo!XXXX!oooooooo!XXXXXXX")
		gbm.AddRow("X!!!!!!!!!!XXXX!!!!!!!!!!XCCCCCC")
		gbm.AddRow("XXXXXXXXXXXXXXXXXXXXXXXXXXCooooC")
		gbm.AddRow("XXXXXXXXXXXXXXXXXXXXXXXXXXCoCCoC")
		gbm.AddRow("XXXXXXXXXXXXXXXXXXXXXXXXXXCoCCoC")
		gbm.AddRow("XXXXXXXXXXXXXXXXXXXXXXXXXXCoCCoC")
		gbm.AddRow("XXXXXXXXXXXXXXXXXXXCCCCCXXCoCCoC")
		gbm.AddRow("XXXXXXXXXXXXXXXXXXXC.ooCXX!ooooC")
		gbm.AddRow("XXXXXXXXXXXXXXXXXXXCCCCCXXCoCCCC")
		gbm.AddRow("XXXXXXXXXXXXXXXXXXXXXXXXXXCoCXXX")			
		scenario.perfectringcount=64
		scenario.inverseperfectringcount=427
		scenario.player.x=17
		scenario.player.y=33-9
		scenario.player.xdirection=0
		scenario.player.ydirection=1	
		
	elseif(scenario.stagenumber==13)then
		scenario.grid.color1={136/256.0, 0/256.0, 238/256,1.0}
		scenario.grid.color2={34/256.0,238/256.0, 170/256,1.0}		
		scenario.background.skycolor={0/256.0,0/256.0,0/256.0,1.0}
		scenario.background.starcolor={0/256.0,34/256.0,238/256.0,1.0}	
		gbm.AddRow("XXXXXXXXXXX...CCCC...XXXXXXXXXXX")
		gbm.AddRow("XXXXXXXXXXX...CCCC...XXXXXXXXXXX")
		gbm.AddRow("..........o...o..o...o..........")
		gbm.AddRow("C.ooo.CC..XXXXC..CXXXX..CC.ooo.C")
		gbm.AddRow("C.ooo.CC..XXXXC..CXXXX..CC.ooo.C")
		gbm.AddRow("C.ooo.CC..XXXXC..CXXXX..CC.ooo.C")
		gbm.AddRow("..........XXXXC!!CXXXX..........")
		gbm.AddRow("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX")
		gbm.AddRow("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX")
		gbm.AddRow("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX")
		gbm.AddRow("XXXXXXXXXXXXXXCCCCXXXXXXXXXXXXXX")
		gbm.AddRow("......XXXXXXXXC!!CXXXXXXXX......")
		gbm.AddRow("......XXXXXXXXC..CXXXXXXXX......")
		gbm.AddRow("C.....XXXXXXXCC..CCXXXXXXX.....C")
		gbm.AddRow("C.XXX.CCXXCCCCCooCCCCCXXCC.XXX.C")
		gbm.AddRow("R.ooo.!CXXC!..o..o..!CXXC!.ooo.R")
		gbm.AddRow("R.ooo.!CXXC!..o..o..!CXXC!.ooo.R")
		gbm.AddRow("C.XXX.CCXXCCCCCooCCCCCXXCC.XXX.C")
		gbm.AddRow("C.....XXXXXXXCC..CCXXXXXXX.....C")
		gbm.AddRow("......XXXXXXXXC..CXXXXXXXX......")
		gbm.AddRow("......XXXXXXXXC!!CXXXXXXXX......")
		gbm.AddRow("XXXXXXXXXXXXXXCCCCXXXXXXXXXXXXXX")
		gbm.AddRow("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX")
		gbm.AddRow("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX")
		gbm.AddRow("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX")
		gbm.AddRow("........o...XXC!!CXX...o........")
		gbm.AddRow("CCC.XXX.XXX.XXC..CXX.XXX.XXX.CCC")
		gbm.AddRow("RRC.ooo.XXX.XXC..CXX.XXX.ooo.CRR")
		gbm.AddRow("CCC.XXX.XXXoXXC..CXXoXXX.XXX.CCC")
		gbm.AddRow("........XXX...o..o...XXX........")
		gbm.AddRow("XXXXXXXXXXX...CCCC...XXXXXXXXXXX")
		gbm.AddRow("XXXXXXXXXXX...CCCC...XXXXXXXXXXX")		
		scenario.perfectringcount=68
		scenario.inverseperfectringcount=492
		scenario.player.x=16
		scenario.player.y=33-16
		scenario.player.xdirection=0
		scenario.player.ydirection=-1	
		
	elseif(scenario.stagenumber==14)then
		scenario.grid.color1={170/256.0, 238/256.0, 0/256,1.0}
		scenario.grid.color2={102/256.0,0/256.0, 238/256,1.0}		
		scenario.background.skycolor={34/256.0,136/256.0,238/256.0,1.0}
		scenario.background.starcolor={238/256.0,238/256.0,238/256.0,1.0}	
		gbm.AddRow("CCC..CCCCCC..CCCCCC..CCCCCC..CCX")
		gbm.AddRow("CCC..CCCCCC!!CCCCCC..CCCCCC!!CCX")
		gbm.AddRow("CC....CCCCXXXXCCCC....CCCCXXXXCC")
		gbm.AddRow("...oo.....oooX!....RR....!XooX!.")
		gbm.AddRow("...oo.....oooX!....RR....!XooX!.")
		gbm.AddRow("CC....CCCCXXXXCCCC....CCCCXooXCC")
		gbm.AddRow("CCC..CCCCCC!!CCCCCC..CCCCCC..CCX")
		gbm.AddRow("CCC..CCCCCC..CCCCCC..CCCCCC..CCX")
		gbm.AddRow("CCC..CCCCCC..CCCCCC..CCCCCC..CCX")
		gbm.AddRow("CCC!!CCCCCC..CCCCCC..CCCCCC..CCX")
		gbm.AddRow("CCXXXXCCCC....CCCCXooXCCCC....CC")
		gbm.AddRow(".!Xooo.....RR....!XooX!....oo...")
		gbm.AddRow(".!Xooo.....RR....!XooX!....oo...")
		gbm.AddRow("CCXXXXCCCC....CCCCXXXXCCCC....CC")
		gbm.AddRow("CCC!!CCCCCC..CCCCCC!!CCCCCC..CCX")
		gbm.AddRow("CCC..CCCCCC..CCCCCC..CCCCCC..CCX")
		gbm.AddRow("CCC..CCCCCC..CCCCCC..CCCCCC..CCX")
		gbm.AddRow("CCC..CCCCCC!!CCCCCC..CCCCCC!!CCX")
		gbm.AddRow("CC....CCCCXXXXCCCC....CCCCXXXXCC")
		gbm.AddRow("...RR....!XooX!....oo.....oooX!.")
		gbm.AddRow("...RR....!XooX!....oo.....oooX!.")
		gbm.AddRow("CC....CCCCXooXCCCC....CCCCXXXXCC")
		gbm.AddRow("CCC..CCCCCC..CCCCCC..CCCCCC!!CCX")
		gbm.AddRow("CCC..CCCCCC..CCCCCC..CCCCCC..CCX")
		gbm.AddRow("CCC..CCCCCC..CCCCCC..CCCCCC..CCX")
		gbm.AddRow("CCC..CCCCCC..CCCCCC!!CCCCCC..CCX")
		gbm.AddRow("CCXooXCCCC....CCCCXXXXCCCC....CC")
		gbm.AddRow(".!XooX!....oo....!Xooo.....RR...")
		gbm.AddRow(".!XooX!....oo....!Xooo.....RR...")
		gbm.AddRow("CCXXXXCCCC....CCCCXXXXCCCC....CC")
		gbm.AddRow("CCC!!CCCCCC..CCCCCC!!CCCCCC..CCX")
		gbm.AddRow("CCC..CCCCCC..CCCCCC..CCCCCC..CCX")	
		scenario.perfectringcount=144
		scenario.inverseperfectringcount=16
		scenario.player.x=5
		scenario.player.y=33-1
		scenario.player.xdirection=0
		scenario.player.ydirection=-1		
	elseif(scenario.stagenumber==15)then
		scenario.grid.color1={0/256.0, 204/256.0, 238/256,1.0}
		scenario.grid.color2={204/256.0,34/256.0, 170/256,1.0}		
		scenario.background.skycolor={0/256.0,0/256.0,136/256.0,1.0}
		scenario.background.starcolor={0/256.0,136/256.0,238/256.0,1.0}
		gbm.AddRow("XXXXXXXXXXXXX..........X!C..oo.C")
		gbm.AddRow("XXXXXXXXXXXXX..C..C..XXXXXXXXXXX")
		gbm.AddRow("XXXXXXXXXXXXX.CooooC.XXXXXXXXXXX")
		gbm.AddRow("XXXXXXXXXXXXX..oooo..XXXXXXXXXXX")
		gbm.AddRow("XXXXXXXXXXXXX..oooo..XXXXXXXXXXX")
		gbm.AddRow("XXXXXXXXXXXXX.CooooC.XXXXXXXXXXX")
		gbm.AddRow("XXXXXXXXXXXXX..C..C..XXXXXXXXXXX")
		gbm.AddRow("XXXXXXXXXXXXX........XXXXXXXXXXX")
		gbm.AddRow("XXXXXXXXXXXXXoXXXXXXXXXXXXXXXXXX")
		gbm.AddRow("XXXCXXXXXXXXXoXXXXXXXXXXXXXCXXXX")
		gbm.AddRow("XXX.XXXXXXXXX.XXXXXXXXXXXXX.XXXX")
		gbm.AddRow("XXXoXXXXXXXXX.XXXXXXXXXXXXXoXXXX")
		gbm.AddRow("XXXoXXXXXXXXX.XXXXXXXXXXXXXoXXXX")
		gbm.AddRow("RCX......X!C..oo.CXXXXXXXXX...oR")
		gbm.AddRow("XXX.XXXXXXXXXXXXXXXXXXXXXXX.XXXX")
		gbm.AddRow("XXXCXXXXXXXXXXXXXXXXXXXXXXXCXXXX")
		gbm.AddRow("XXX!XXXXXXXXXXXXXXXXXXXXXXX!XXXX")
		gbm.AddRow("XXXCXXXXXXXXXXXXXXXXXXXXXXXXXXXX")
		gbm.AddRow("XXX.XXXXXXXXCCCCCXXXXXXXXXX.XXXX")
		gbm.AddRow("XXX.........CoooCXX.........XXXX")
		gbm.AddRow("XXX.CCCoCCC.CoooCXX.CCXXXCC.XXXX")
		gbm.AddRow("XXX.CCCoCCC.CoooCXX.CCXoXCC.XXXX")
		gbm.AddRow("XXX.CCCoCCC.C...CXX.CCXoXCC.XXXX")
		gbm.AddRow("XXX.ooooooo.C...CXX.ooooooo.XXXX")
		gbm.AddRow("XXX.CCCoCCC.C...CXX.CCXoXCC.XXXX")
		gbm.AddRow("XXX.CCCoCCC.CoooCXX.CCXoXCC.XXXX")
		gbm.AddRow("XXX.CCCoCCC.CoooCXX.CCXXXCC.XXXX")
		gbm.AddRow("XXX.........CoooCXX.........XXXX")
		gbm.AddRow("XXXXXXXXXXXXCCCCCXXXXXXXXXXoXXXX")
		gbm.AddRow("XXXXXXXXXXXXXXXXXXXXXXXXXXXoXXXX")
		gbm.AddRow("XXXXXXXXXXXXXXXXXXXXXXXXXXX.XXXX")
		gbm.AddRow("XXXXXXXXXXXXXXXXXXXXXXXXXXX.XXXX")
		scenario.perfectringcount=57
		scenario.inverseperfectringcount=666
		scenario.player.x=15
		scenario.player.y=33-25
		scenario.player.xdirection=0
		scenario.player.ydirection=1		
	elseif(scenario.stagenumber==16)then
		scenario.grid.color1={0/256.0, 0/256.0, 204/256,1.0}
		scenario.grid.color2={204/256.0,204/256.0, 204/256,1.0}		
		scenario.background.skycolor={34/256.0,0/256.0,170/256.0,1.0}
		scenario.background.starcolor={136/256.0,238/256.0,204/256.0,1.0}				
		gbm.AddRow("!!!!!.........CCCC.........!!!!!")
		gbm.AddRow("!oooo......................oooo!")
		gbm.AddRow("!oooX......................Xooo!")
		gbm.AddRow("!oooX......................Xooo!")
		gbm.AddRow("!oXXX....!!!!!!!!!!!!!!....XXXo!")
		gbm.AddRow("........CCXXXXXXXXXXXXCC........")
		gbm.AddRow(".......CCCXXXXXXXXXXXXCCC.......")
		gbm.AddRow("......CCC..............CCC......")
		gbm.AddRow(".....CCC................CCC.....")
		gbm.AddRow("....!CC..................CC!....")
		gbm.AddRow("....!XX...!!!!!!!!!!!!...XX!....")
		gbm.AddRow("....!XX...!CCCC!!CCCC!...XX!....")
		gbm.AddRow("....!XX...!CXXX!!XXXC!...XX!....")
		gbm.AddRow("....!XX...!CXXX!!XXXC!...XX!....")
		gbm.AddRow("C...!XX...!CXXX!!XXXC!...XX!...C")
		gbm.AddRow("C...!XX...!!!!!oo!!!!!...XX!...C")
		gbm.AddRow("C...!XX...!!!!!oo!!!!!...XX!...C")
		gbm.AddRow("C...!XX...!CXXX!!XXXC!...XX!...C")
		gbm.AddRow("....!XX...!CXXX!!XXXC!...XX!....")
		gbm.AddRow("....!XX...!CXXX!!XXXC!...XX!....")
		gbm.AddRow("....!XX...!CCCC!!CCCC!...XX!....")
		gbm.AddRow("....!XX...!!!!!!!!!!!!...XX!....")
		gbm.AddRow("....!CC..................CC!....")
		gbm.AddRow(".....CCC................CCC.....")
		gbm.AddRow("......CCC..............CCC......")
		gbm.AddRow(".......CCCXXXXXXXXXXXXCCC.......")
		gbm.AddRow("........CCXXXXXXXXXXXXCC........")
		gbm.AddRow("!oXXX....!!!!!!!!!!!!!!....XXXo!")
		gbm.AddRow("!oooX......................Xooo!")
		gbm.AddRow("!oooX......................Xooo!")
		gbm.AddRow("!oooo......................oooo!")
		gbm.AddRow("!!!!!......................!!!!!")
		scenario.perfectringcount=64
		scenario.inverseperfectringcount=36
		scenario.player.x=15
		scenario.player.y=33-24
		scenario.player.xdirection=1
		scenario.player.ydirection=0				
	end	
	gbm.Build(scenario.grid)
	
	
	scenario.player.grid_facing=math.atan2(scenario.player.ydirection,-scenario.player.xdirection)



end