do
	local super=TRAININGGROUNDS_Scenario
	TRAININGGROUNDS_SECRET35_Scenario_35SpheresMenu = TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_SECRET35_Scenario_35SpheresMenu

	local NUM_STAGES=16
	
	function class:Populate()
	
		if(TRAININGGROUNDS_UNLOCKRACE35_SAVEDATA==nil)then
			TRAININGGROUNDS_UNLOCKRACE35_SAVEDATA={}
			TRAININGGROUNDS_UNLOCKRACE35_SAVEDATA.inversemode=false
			TRAININGGROUNDS_UNLOCKRACE35_SAVEDATA.clear={}
			TRAININGGROUNDS_UNLOCKRACE35_SAVEDATA.inverseclear={}
		else
			self.inversemode=TRAININGGROUNDS_UNLOCKRACE35_SAVEDATA.inversemode
		end
		if(self.inversemode==nil)then self.inversemode=false end
	
		local scen=self
	
		local x=-1
		local y=0
		
		self.startbuttons={}
		local startbutton
		
		--local buttonx=0
		local buttonx=self.environment.game.window.frame:GetWidth()/2
		for j=1,NUM_STAGES do				
			x=x+1	
			if(x>7)then x=0;y=y+1 end
			startbutton=TRAININGGROUNDS_Button.new()
			startbutton:Setup(self.environment.game.environment_hud)
			startbutton.x=buttonx+115*(x-3.5)
			startbutton.y=self.environment.game.window.frame:GetHeight()/2+230-90*y
			startbutton.drawable.width=100;startbutton.drawable.height=80	
			startbutton.drawable.frame:SetScript("OnClick",function()					
					--self:OnStartButton()
					local scenario
					scenario=self.environment.game:LoadScenarioByClass(TRAININGGROUNDS_SECRET35_Scenario_35Spheres)
					scenario.stagenumber=j
					scenario.inversemode=scen.inversemode
				end)
			tinsert(self.startbuttons,startbutton)
		end	
		
		local inversebutton		
		inversebutton=TRAININGGROUNDS_Button.new()
		inversebutton:Setup(self.environment.game.environment_hud)
		inversebutton.x=640
		inversebutton.y=200
		inversebutton.drawable.width=200;inversebutton.drawable.height=120					
		self.inversebutton=inversebutton
		self:SetMenuButtonText()		
		inversebutton.drawable.frame:SetScript("OnClick",function()					
				scen.inversemode=not scen.inversemode
				TRAININGGROUNDS_UNLOCKRACE35_SAVEDATA.inversemode=scen.inversemode
				scen:SetMenuButtonText()
			end)		
		tinsert(self.startbuttons,inversebutton)
		
		
		
		--local OFFSETX=260
		local OFFSETX=0
		local OFFSETY=-80
		local text
		text=TRAININGGROUNDS_Debug_Text.new();text:Setup(self.environment.game.environment_hud)
		text.x=OFFSETX+self.environment.game.window.frame:GetWidth()/2;text.y=OFFSETY+self.environment.game.window.frame:GetHeight()/2-125-0
		text.drawable.width=500;text.drawable.height=70
		text:SetText("Steer with arrow keys or WASD, jump with spacebar")
		text=TRAININGGROUNDS_Debug_Text.new();text:Setup(self.environment.game.environment_hud)
		text.x=OFFSETX+self.environment.game.window.frame:GetWidth()/2;text.y=OFFSETY+self.environment.game.window.frame:GetHeight()/2-125-25
		text.drawable.width=500;text.drawable.height=70
		text:SetText("Run through the blue spheres to turn them red")
		text=TRAININGGROUNDS_Debug_Text.new();text:Setup(self.environment.game.environment_hud)
		text.x=OFFSETX+self.environment.game.window.frame:GetWidth()/2;text.y=OFFSETY+self.environment.game.window.frame:GetHeight()/2-125-50
		text.drawable.width=500;text.drawable.height=70
		text:SetText("Outline a group of blue spheres in red to turn them into rings")

	end

	function class:SetMenuButtonText()
		for j=1,NUM_STAGES do
			local startbutton=self.startbuttons[j]
			local text="Stage "..tostring(j).."\r"
			if(self.inversemode==false)then
				if(TRAININGGROUNDS_UNLOCKRACE35_SAVEDATA.clear[j]==2)then
					text=text.."(Perfect)"
				elseif(TRAININGGROUNDS_UNLOCKRACE35_SAVEDATA.clear[j]==1)then	
					text=text.."(Clear)"
				else
					text=text.." "
				end
			else
				if(TRAININGGROUNDS_UNLOCKRACE35_SAVEDATA.inverseclear[j]==2)then
					text=text.."(Perfect)"
				elseif(TRAININGGROUNDS_UNLOCKRACE35_SAVEDATA.inverseclear[j]==1)then	
					text=text.."(Clear)"
				else
					text=text.." "
				end
			end
			startbutton:SetText(text)
		end
		if(not self.inversemode)then
			text="Standard Mode"
		else
			text="Inverse Mode"
		end
		text=text.."\r".."(click to toggle)"	
		self.inversebutton:SetText(text)
	end
	
	
	
	function class:OnEscapeKey()
		self.environment.game:LoadScenarioByClass(TRAININGGROUNDS_Scenario_Menu_Minigames)
	end	


	
end
	




TRAININGGROUNDS_ScenarioList_Minigames:RegisterScenario(TRAININGGROUNDS_SECRET35_Scenario_35SpheresMenu,"Get Spheres","A dizzying test of precise timing and quick reflexes!")
