do
	local super=TRAININGGROUNDS_GameObject
	TRAININGGROUNDS_SECRET35_Whiteout=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_SECRET35_Whiteout
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.alpha=0
	end
	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		self.alpha=self.alpha+elapsed*.75
		if(self.alpha>2)then 
			self.alpha=2 
			local inversemode=self.environment.game.scenario.inversemode
			local menu=self.environment.game:LoadScenarioByClass(TRAININGGROUNDS_SECRET35_Scenario_35SpheresMenu)
			menu.inversemode=inversemode
		end
	end
	
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_SECRET35_Whiteout_Drawable.new()
		self.drawable:Setup(self,self.environment)
	end
end


do
	local super=TRAININGGROUNDS_Drawable
	TRAININGGROUNDS_SECRET35_Whiteout_Drawable=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_SECRET35_Whiteout_Drawable
	
	function class:CreateFrame()
		self.frame=TRAININGGROUNDS_ReusableFrames:GetFrame()
		self.frame:Show()	
	end
	
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.shadowframelayer
	end
	
	function class:SetFrameAppearance()			
		self.frame:SetAllPoints(self.parentframe)
		self.frame.texture:SetColorTexture(1,1,1,1)
		self.frame.texture:Show()
		--self.frame:SetAlpha(1)
	end
	
	function class:ArrangeFrame(parentanchor,cposx,cposy,cposz,cangx,cangy,cangz)
		super.ArrangeFrame(self,parentanchor,cposx,cposy,cposz,cangx,cangy,cangz)
		
		self.frame:SetAllPoints(self.parentframe)
		self.frame:SetFrameLevel(255)
		self:SetAlpha(self.owner.alpha)
		
	end	
end