do
	local super=TRAININGGROUNDS_Drawable_CharacterModel
	TRAININGGROUNDS_SECRET35_Drawable_Runner35 = TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_SECRET35_Drawable_Runner35
	
	local sizemod={}
	sizemod["Default"]=1.0
	sizemod["Human3"]=0.9
	sizemod["Human2"]=1.0
	sizemod["BloodElf3"]=1.1
	sizemod["BloodElf2"]=0.9
	 sizemod["DarkIronDwarf3"]=1.3
	 sizemod["DarkIronDwarf2"]=1.0
	sizemod["Draenei3"]=1.0
	sizemod["Draenei2"]=0.7
	sizemod["Dwarf3"]=1.3
	sizemod["Dwarf2"]=1.0
	sizemod["Gnome3"]=1.0
	sizemod["Gnome2"]=1.0
	sizemod["Goblin3"]=1
	sizemod["Goblin2"]=1
	sizemod["HighmountainTauren3"]=0.625
	sizemod["HighmountainTauren2"]=0.5
	sizemod["KulTiran3"]=0.8
	sizemod["KulTiran2"]=0.7
	sizemod["LightforgedDraenei3"]=1.0
	sizemod["LightforgedDraenei2"]=0.7
	 sizemod["MagharOrc3"]=1.0
	 sizemod["MagharOrc2"]=0.8
	sizemod["Nightborne3"]=0.9
	sizemod["Nightborne2"]=0.8
	sizemod["NightElf3"]=0.9
	sizemod["NightElf2"]=0.8
	sizemod["Orc3"]=1.0
	sizemod["Orc2"]=0.8
	sizemod["Pandaren3"]=1.0
	sizemod["Pandaren2"]=0.85
	 sizemod["Scourge3"]=0.95
	sizemod["Scourge2"]=0.8
	sizemod["Tauren3"]=0.625
	sizemod["Tauren2"]=0.5
	sizemod["Troll3"]=0.95
	sizemod["Troll2"]=0.675
	sizemod["VoidElf3"]=1.1
	sizemod["VoidElf2"]=0.9
	-- sizemod["Vulpera3"]=
	-- sizemod["Vulpera2"]=
	sizemod["Worgen3"]=0.9
	sizemod["Worgen2"]=0.75
	sizemod["ZandalariTroll3"]=0.85
	sizemod["ZandalariTroll2"]=0.675
	
	
	local offsetmod={}
	offsetmod["Default"]=0
	offsetmod["Human3"]=-5
	offsetmod["Human2"]=0
	offsetmod["BloodElf3"]=-5
	offsetmod["BloodElf2"]=-5
	 offsetmod["DarkIronDwarf3"]=0
	 offsetmod["DarkIronDwarf2"]=-20
	offsetmod["Draenei3"]=-10
	offsetmod["Draenei2"]=-30
	offsetmod["Dwarf3"]=0
	offsetmod["Dwarf2"]=-20
	offsetmod["Gnome3"]=-10
	offsetmod["Gnome2"]=-5
	offsetmod["Goblin3"]=-15
	offsetmod["Goblin2"]=0
	offsetmod["HighmountainTauren3"]=-30
	offsetmod["HighmountainTauren2"]=-20
	offsetmod["KulTiran3"]=-5
	offsetmod["KulTiran2"]=-5
	offsetmod["LightforgedDraenei3"]=-10
	offsetmod["LightforgedDraenei2"]=-30
	 offsetmod["MagharOrc3"]=-10
	 offsetmod["MagharOrc2"]=0
	offsetmod["Nightborne3"]=-10
	offsetmod["Nightborne2"]=-10
	offsetmod["NightElf3"]=-10
	offsetmod["NightElf2"]=-10
	offsetmod["Orc3"]=-10
	offsetmod["Orc2"]=0
	offsetmod["Pandaren3"]=-30
	offsetmod["Pandaren2"]=-20
	offsetmod["Scourge3"]=0
	offsetmod["Scourge2"]=-5
	offsetmod["Tauren3"]=-30
	offsetmod["Tauren2"]=-20
	offsetmod["Troll3"]=-5
	offsetmod["Troll2"]=10
	offsetmod["VoidElf3"]=-5
	offsetmod["VoidElf2"]=-5
	-- offsetmod["Vulpera3"]=
	-- offsetmod["Vulpera2"]=
	offsetmod["Worgen3"]=-10
	offsetmod["Worgen2"]=0
	offsetmod["ZandalariTroll3"]=-5
	offsetmod["ZandalariTroll2"]=10
	
	function class:CreateFrame()
		self.frame=TRAININGGROUNDS_ReusableModelFrames:GetFrame()
		self.frame:Show()
	end
	
	local QuickTryOn=function(self,itemid)		
		local link=TRAININGGROUNDS_Equipment_GetItemTooltip(itemid)
		self.frame:TryOn(link)
	end

	function class:SetFrameAppearance()	
		self.modelinfo=TRAININGGROUNDS_ModelInfo.new()
		self.modelinfo:Setup()
	
		--self.frame:SetDisplayInfo(81018)	--Kiro
		self.frame:SetUnit("player")
		

		
		local unitstr,unittag,unitid=UnitRace("player") 
		self.unittype=unittag .. UnitSex("player")
		-- --print("Unittype:",self.unittype)
		-- --!!! --------------------------------
		-- self.frame:SetCustomRace(25,1)
		-- self.unittype="Pandaren3"	--!!!
		-- self.frame:Undress()
		-- QuickTryOn(self,27514)	--legs
		-- QuickTryOn(self,27787)	--chest
		-- QuickTryOn(self,27867) --feet
		-- QuickTryOn(self,28206)	--head
		-- QuickTryOn(self,27765) --wrist
		-- QuickTryOn(self,27831) --shoulder
		-- QuickTryOn(self,28124) --waist
		-- QuickTryOn(self,28396) --hands
		-- --------------------------------------
		self.frame:SetSheathed(true)
		
		
		self:SetLighting(1,1,1,1,0.6,1,1,1)	
	end
	
	function class:SetAnimationSystem()
		self.animationsystem=TRAININGGROUNDS_Secret35_RunnerAnimationSystem.new()
		self.animationsystem:Setup(self)
		self.animationsystem.owner=self
	end
	
	
	function class:ArrangeFrame(parentanchor,cposx,cposy,cposz,cangx,cangy,cangz)
		self.frame:ClearAllPoints()
		
		--TODO NEXT: without this line, character breaks scrollframe boundaries,
		-- but they still unexpectedly move with the game window when the window is dragged.
		-- what was this frame parented to earlier?		
		self.frame:SetParent(self.parentframe)
		
		---------------------------------------------------------------------------------------------
		---- in case we ever need to recalculate ground value:
		-- local x,y,z
		-- local cangz=0.75	--TODO: global?
		-- local coffsetx=0
		-- local coffsety=0
		-- local playerheight=0
		-- x=math.sin(cangz)*HZ_CAMERA_DISTANCE
		-- y=math.cos(cangz)*HZ_CAMERA_DISTANCE		
		-- z=-(CAMERA_HEIGHT+playerheight)
		-- x,y,z=TRAININGGROUNDS_SECRET35_MatrixMultiplicationRotation(x,y,z,cangz,0,0)
		-- x,y=TRAININGGROUNDS_SECRET35_PerspectiveTransform(x,y,z,far)		
		-- x=x*WORLD_SCALE_MULTIPLIER;y=y*WORLD_SCALE_MULTIPLIER		
		-- y=y-screenoffsety
		--print("Draw_Run35 ArrangeFrame",x,y)	
		---------------------------------------------------------------------------------------------

		local scale=sizemod[self.unittype]
		if(scale==nil)then scale=sizemod["Default"] end
		local offset=offsetmod[self.unittype]
		if(offset==nil)then offset=offsetmod["Default"]end
		
		local ground_x,ground_y=0,-127.7
		local height_y=self.owner.z*50		--TODO: this *50 is arbitary and .z already has a multipler attached to it
													-- see if we can change .z to work in gridtile_units
		local offset_y=-0
		local x,y=ground_x,ground_y+height_y+offset_y+offset


		
		
		self.frame:SetPoint(self.anchor,self.parentframe,parentanchor,x,y)		
		--self.frame:SetPoint(self.anchor,self.parentframe,parentanchor,0,-150)	--use as temporary bandage if above line breaks
		
		local yaw=self.owner.currentfacing
		local pitch=-math.pi/3
		--self:SetFrameSizeAndOrientation(150,150,yaw,-math.pi/2+0.75,1)
		--self:SetFrameSizeAndOrientation(190,190,yaw,-math.pi/2+0.75,1)
		

		self:SetFrameSizeAndOrientation(190*1.4*scale,190*1.4*scale,yaw,-math.pi/2+0.75,1)

		--self.frame:SetLight(true,false, -.5, 0, -.5,
		self.frame:SetLight(true,false, -1, 0, 0,
						self.lightAA,self.lightAR,self.lightAG,self.lightAB,
						self.lightDA,self.lightDR,self.lightDG,self.lightDB)		
						
		-- self.frame.texture:Show()--!!!
		self.frame:SetFrameLevel(175)
	end
	
	
	

	
end
