
do
	--local super=TRAININGGROUNDS_Mobile	
	-- as long as we inherit GameObject instead of Mobile, we shouldn't have to worry too much about future-proofing	
	local super=TRAININGGROUNDS_Drawable_Sprite
	TRAININGGROUNDS_SECRET35_Drawable_Shadow35 = TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_SECRET35_Drawable_Shadow35	
	function class:SetCustomInfo()
		self.anchor="CENTER"
		self.alpha=1
	end
	function class:CreateFrame()
		self.frame=TRAININGGROUNDS_ReusableFrames:GetFrame()
		self.frame:Show()
	end	
	function class:SetFrameAppearance()	
		self.frame.texture:SetTexture("Interface\\AddOns\\TrainingGrounds\\Assets\\Graphics\\shadow.tga")
		self:SetColor(0,0,0,1.0)
	end	
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.shadowframelayer
	end	
	function class:ArrangeFrame(parentanchor,cposx,cposy,cposz,cangx,cangy,cangz)
		self.frame:ClearAllPoints()		
		self.frame:SetParent(self.parentframe)
		local ground_x,ground_y=0,-127.7
		local x,y=ground_x,ground_y
		self.frame:SetPoint(self.anchor,self.parentframe,parentanchor,x,y)		
		local yaw=self.owner.currentfacing
		local pitch=-math.pi/3
		--TODO: calculate (and then bake) ystretch based on camera angle
			-- 0.84375 is height ratio from the original game 
		self:SetFrameSizeAndOrientation(125,125*0.84375,yaw,-math.pi/2+0.75,1)
	end
	
end
